# pw -- Password generator

A highly configurable password generator for Linux, macOS, and OpenBSD, written
in C++.

## Quick start

### Build

#### Dependencies

First build & install
[libscnumerics](https://git.bobpolis.com/bob/libscnumerics).

Then:

`make`

### Install

`sudo make install`

Or, on OpenBSD:

`doas gmake install`

### Usage

`pw`

Generate password using default settings: at lease one digit, at least one lower
case letter, at least one upper case letter, at least one symbol from the set
`_-=+<>,.!@#$%^&*`, and a length of 24 characters.

## Examples

Generate a password with at least one lower case letter, at least two upper case
letters, at least three digits, at least four symbols, and a length of 20
characters:

`pw -l 1 -u 2 -d 3 -s 4 -c 20`

or, more compact:

`pw -l1 -u2 -d3 -s4 -c20`

The same, but now with symbols chosen from the set `+-=@`:

`pw -l1 -u2 -d3 -s4 -c20 -S '+-=@'`

## Documentation

Full documentation is in the man page:

`man pw`
